﻿using esoft.Class;
using esoft.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.NetworkInformation;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace esoft.Pages
{
    /// <summary>
    /// Логика взаимодействия для ExecutorsListPage.xaml
    /// </summary>
    public partial class ExecutorsListPage : Page
    {
        ActualContext actualContext = new ActualContext();                 // Контекст таблиц
        ExecuterFill executer = new ExecuterFill();                       // Полученный контекст формы
        List<ExecuterFill> executerContext = new List<ExecuterFill>();   // Список исполнителей

        public ExecutorsListPage()
        {
            InitializeComponent();
            LViewExecutors.ItemsSource = Class.ExecuterFill.Fill();
            FillForm();
        }

        private void FillForm()
        {
            List<User> usersExecutor = actualContext.Users.Where(user => actualContext.Executor.Any(ex => ex.ID == user.ID)).ToList(); // Получение списка исполнителей
            cbExecutor.ItemsSource = UserInFIO.GroupUser(usersExecutor);

            List<User> usersManager = actualContext.Users.Where(user => actualContext.Manager.Any(manager => manager.ID == user.ID)).ToList(); // Получение списка менеджеров
            cbManager.ItemsSource = UserInFIO.GroupUser(usersManager);
        }

        private void BtnDeleteExecutor_Click(object sender, RoutedEventArgs e)
        {

        }

        private void BtnAddExecutor_Click(object sender, RoutedEventArgs e)
        {

        }

        private void BtnUpdate_Click(object sender, RoutedEventArgs e)
        {
            LViewExecutors.ItemsSource = Class.ExecuterFill.Fill();
        }

        private void LViewExecutors_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {

        }

        private void FilterTasks()
        {
            // Получение актуальных данных задач из базы или контекста приложения
            executerContext = Class.ExecuterFill.Fill();

            if (cbExecutor.SelectedItem != null)
            {
                string selectedExecutor = cbExecutor.SelectedItem.ToString();
                executerContext = executerContext.Where(task => task.FioUser == selectedExecutor).ToList();
            }

            if (cbManager.SelectedItem != null)
            {
                string selectedManager = cbManager.SelectedItem.ToString();
                executerContext = executerContext.Where(task => task.FioManager == selectedManager).ToList();
            }

            if (!string.IsNullOrEmpty(Search.Text))
            {
                string searchText = Search.Text.ToLower(); // Преобразование текста поиска к нижнему регистру (для удобства сравнения)

                // Фильтрация задач по содержанию текста в полях Title
                executerContext = executerContext.Where(task => task.FioUser.ToLower().Contains(searchText)).ToList();
            }

            LViewExecutors.ItemsSource = executerContext;
        }

        private void cbManager_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            FilterTasks();
        }

        private void cbExecutor_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            FilterTasks();
        }
        private void Search_TextChanged(object sender, TextChangedEventArgs e)
        {
            FilterTasks();
        }
        private void btnClearFilter_Click(object sender, RoutedEventArgs e)
        {
            // Очистка выбранных значений комбо боксов
            cbExecutor.SelectedItem = null;
            cbManager.SelectedItem = null;
            Search.Text = string.Empty;

            // Очистка фильтров и отображение всех задач без фильтрации
            LViewExecutors.ItemsSource = Class.ExecuterFill.Fill();
        }
    }
}
